Fix compilation with readline 7
https://sourceforge.net/p/clisp/bugs/688/
--- modules/readline/readline.lisp.orig	2010-01-06 16:18:03.000000000 -0600
+++ modules/readline/readline.lisp	2017-08-20 23:38:51.000000000 -0500
@@ -58,6 +58,14 @@
 (def-c-type readline-vcpfunc (c-function (:arguments (text c-string))))
 (def-c-type keymap c-pointer)
 
+(c-lines "#if RL_VERSION_MAJOR >= 7
+typedef unsigned long rl_readline_state_t;
+#else
+typedef int rl_readline_state_t;
+#endif~%")
+(c-lines "#define HAVE_RL_READLINE_STATE_T 1~%")
+(def-c-type rl_readline_state_t)
+
 ;;; Basic behavior
 (def-call-out readline (:name "readline")
   (:documentation
@@ -424,7 +432,7 @@
    "The version of this incarnation of the readline library, e.g., 0x0402."))
 (def-c-var gnu-readline-p (:name "rl_gnu_readline_p") (:type int)
   (:documentation "True if this is real GNU readline."))
-(def-c-var readline-state (:name "rl_readline_state") (:type int)
+(def-c-var readline-state (:name "rl_readline_state") (:type rl_readline_state_t)
   (:documentation "Flags word encapsulating the current readline state."))
 (def-c-var editing-mode (:name "rl_editing_mode") (:type int)
   (:documentation "Says which editing mode readline is currently using.
